lab7/myimgur/images/urls.py
from django.urls import path

from .views import image_list, image_detail, image_create, comment_create


app_name= "images"
urlpatterns = [
    path('', image_list, name="list"),
    path('<int:image_id>/', image_detail, name="detail"),
    path('new/', image_create, name="create"),
    path('<int:image_id>/comments/new/', comment_create, name="comment_create")
]

lab7/myimgur/myimgur/urls.py
from django.contrib import admin
from django.urls import path, include

from images.views import homepage

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', homepage, name="homepage"),
    path('images/', include('images.urls')),
]

lab7/myimgur/images/models.py
from django.db import models

# Create your models here.
class Image(models.Model):
    title = models.CharField(max_length=128)
    desc = models.CharField(max_length=512)
    pub_date = models.DateTimeField()
    url = models.CharField(max_length=512)

    def __str__(self):
        return f"{self.id} - {self.title}"
    
class Comment(models.Model):
    text = models.CharField(max_length=512)
    created_at = models.DateTimeField(auto_now_add=True)
    author = models.CharField(max_length=64)
    image = models.ForeignKey(Image, on_delete=models.CASCADE)

    def __str__(self):
        return f"{self.image.id}: {self.text[:25]}"

lab7/myimgur/images/views.py
from django.shortcuts import render, get_object_or_404
from django.http import HttpResponse, HttpResponseRedirect

from .models import Image

# Create your views here.
def homepage(request):
    images_count = Image.objects.count()
    context = {
        "count": images_count,
    }
    return render(request, 'images/homepage.html', context)

def image_list(request):
    images = Image.objects.all()
    context = {
        "images": images
    }
    return render(request, 'images/image_list.html', context)

def image_detail(request, image_id):
    image = get_object_or_404(Image, pk=image_id)
    comments =image.comment_set.all()
    context = {
        "image": image,
        "comments": comments,
    }
    return render(request, 'images/image_detail.html', context)

def image_create(request):
    if request.method == "POST":
        title = request.POST['title']
        desc = request.POST['desc']
        pub_date = request.POST['pub_date']
        url = request.POST['url']

        image = Image(
            title=title,
            desc=desc,
            pub_date=pub_date,
            url=url
        )
        image.save()
        return HttpResponseRedirect (f"/images/{image.id}/")
    
    context = {}
    return render(request, 'images/image_create.html', context)    
    
def comment_create(request, image_id):
    if request.method == "POST":
        image = get_object_or_404(Image, pk=image_id)
        author = request.POST['author']
        text = request.POST['text']
        #kreiraj komentar
        image.comment_set.create(
            author=author,
            text=text,
        )

    return HttpResponseRedirect (f"/images/{image.id}/")
    

lab7/myimgur/images/templates/images/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>
    <div>
        <a href="/">Home</a>
        <a href="{% url 'images:list' %}">Sve slike</a>
        <a href="{% url 'images:create' %}">Obajavi sliku</a>
    </div>
    <h1>My images</h1>
    {% block content %}
    {% endblock content %}
</body>
</html>

lab7/myimgur/images/templates/images/homepage.html
{% extends 'images/base.html' %}

{% block content %}
<p>Imamo puno slika u bazi: 
    {{ count }} komada!
</p>
<a href="{% url 'images:list' %}">
    <h1>Pogledaj ih i ti!</h1>
</a>
    




{% endblock content %}

lab7/myimgur/images/templates/images/image_create.html
{% extends 'images/base.html' %}

    {% block content %}

    <h1>Objavi svoju sliku</h1>
    <form action="{% url 'images:create' %}" method="post">
        {% csrf_token %}

        <label for="">Title</label>
        <input type="text" name="title" id=""><br>
        <label for="">Description </label>
        <input type="text" name="desc" id=""><br>
        <label for="">Pub date</label>
        <input type="date" name="pub_date" id=""><br>
        <label for="">URL</label>
        <input type="text" name="url" id=""><br>
        <input type="submit" value="Objavi sliku">
    </form>

    {% endblock content %}

lab7/myimgur/images/templates/images/image_detail.html
{% extends 'images/base.html' %}

{% block content %}
<div>
    <h2>{{ image.title }}</h2>
    <h3>{{ image.desc }}</h3>
    <p>Objavljeno: {{ image.pub_date }}</p>
    <img src="{{ image.url }}" style="width: 500px">
</div>
<div>
    <form action="{% url 'images:comment_create' image.id %}" method="post">
        {% csrf_token %}
        <label for="">Author</label>
        <input type="text" name="author" id=""><br>
        <label for="">Komentar</label>
        <input type="text" name="text" id=""><br>
        <input type="submit" value="Komentiraj">
    </form>
    <h2>Komentari</h2>
    {% for comment in comments %}
        <p><strong>{{ comment.author }}:</strong>
            {{ comment.text }}
        </p>
        <p><small>{{ comment.created_at }}</small></p>
        <hr>
        {% empty %}
        <strong>Nema još komentara. Budi prvi komentiraj</strong>
    {% endfor %}
</div>
{% endblock content %}

lab7/myimgur/images/templates/images/image_list.html
{% extends 'images/base.html' %}

{% block content %}
<div>
    {% for image in images %}
        <p>
            <a href="{% url 'images:detail' image.id %}">
                {{ image.title }}
            </a>
        </p>
        <img src="{{ image.url }}"
             style="width: 100px;">
    {% endfor %}
</div>
{% endblock content %}